/* This demo program will decrypt a PGP encrypted */
/* text buffer.                                   */

#import <stdio.h>
#import <stdlib.h>
#import <pgp.h>
#import <Foundation/Foundation.h>
#import <Foundation/NSString.h>
#import <Foundation/NSData.h>
#import <PGPserver.h>

int main(int argc, char *argv[])
{
    PGPserver *pgpCryptor;
    NSData *plainData;
    NSData *cipherData;
    NSString *plainString;
    char passphraseBuf[128];
    NSString *passPhrase;
    int pgpError;
    id pool = [[NSAutoreleasePool alloc] init];

    /* Initialize a cryptor object */
    pgpCryptor = [[PGPserver alloc] init];

    if(pgpCryptor == nil) {
	fprintf(stderr,"Could not initialize a PGP cryptor.  See console for details\n");
	exit(1);
    }


    /* You should have an encrypted file named tstFile.asc in   */
    /* this test directory.  You can generate an encrypted file */
    /* Using the 'encrypt' test program and redirecting output  */
    /* to tstFile.asc                                           */

    /* Initialize some encrypted data...                        */
    cipherData = [NSData dataWithContentsOfFile:@"./tstFile.asc"];

    /* Get the decryption passphrase */
    printf("Passphrase (warning - characters will echo to screen): ");
    gets(passphraseBuf);
    passPhrase = [NSString stringWithCString:passphraseBuf];

    /* Decrypt the cipherData */
    plainData = [pgpCryptor decryptData:cipherData
			     passPhrase:passPhrase
			          error:&pgpError];

    /* Check for errors */
    if(pgpError != 0) {
	fprintf(stderr,"MAIN:  PGP Error %d on Encrypt\n",pgpError);
	exit(1);
    }


    /* Print the results */
    plainString = [[NSString alloc] initWithData:plainData encoding:NSASCIIStringEncoding];
    printf("\n%s\n\n",[plainString cString]);

    [plainString release];
    [pgpCryptor release];
    [pool release];

    exit(0);
}
