/* This demo program will encrypt a text buffer   */
/* using the public key PGP algorithm             */

#import <stdio.h>
#import <stdlib.h>
#import <pgp.h>
#import <Foundation/Foundation.h>
#import <Foundation/NSString.h>
#import <Foundation/NSData.h>
#import <PGPserver.h>

int main(int argc, char *argv[])
{
    id pgpCryptor;
    NSData *plainData;
    NSData *cipherData;
    NSString *cipherString;
    id userIDArray;
    char plainTextBuffer[] = "Squeamish Ossifrage\n";
    int pgpError;
    id pool = [[NSAutoreleasePool alloc] init];

    /* Initialize a cryptor object */
    pgpCryptor = [[PGPserver alloc] init];

    if(pgpCryptor == nil) {
	fprintf(stderr,"Could not initialize a PGP cryptor.  See console for details\n");
	exit(1);
    }

    /* Initialize the plaintext data, and userID with which to encrypt */
    plainData = [NSData dataWithBytes:plainTextBuffer length:1+strlen(plainTextBuffer)];
    userIDArray = [NSMutableArray arrayWithObjects:NSUserName(),nil];

    /* Encrypt the data */
    cipherData = [pgpCryptor encryptData:plainData 
			        withKeys:userIDArray 
			      passPhrase:nil
			           error:&pgpError];

    /* Check for errors */
    if(pgpError != 0) {
	fprintf(stderr,"MAIN:  PGP Error %d on Encrypt\n",pgpError);
	exit(1);
    }

    /* Print the encrypted results */
    cipherString = [[NSString alloc] initWithData:cipherData encoding:NSASCIIStringEncoding];
    printf("\n%s\n\n",[cipherString cString]);

    /* Clean up */
    [cipherString release];
    [pgpCryptor release];
    [pool release];

    exit(0);
}
