/* This demo program will encrypt and sign */
/* a text buffer                           */


#import <stdio.h>
#import <stdlib.h>
#import <pgp.h>
#import <Foundation/Foundation.h>
#import <Foundation/NSString.h>
#import <Foundation/NSData.h>
#import <PGPserver.h>

int main(int argc, char *argv[])
{
    id pgpCryptor;
    NSString *plainString = @"Squeamish Ossifrage\n";
    NSData *plainData;
    NSData *cipherData;
    NSString *cipherString;
    NSMutableArray *userIDArray;
    char passphraseBuf[128];
    NSString *passPhrase;
    int pgpError;
    id pool = [[NSAutoreleasePool alloc] init];

    /* Initialize a cryptor object */
    pgpCryptor = [[PGPserver alloc] init];

    /* Initialize some plaintext */
    plainData = [plainString dataUsingEncoding:NSASCIIStringEncoding];

    /* Initialize a userID with which to encrypt */
    userIDArray = [NSMutableArray arrayWithObjects:NSUserName(),nil];

    /* Get a passphrase */
    printf("Passphrase (warning - characters will echo to screen): ");
    gets(passphraseBuf);
    passPhrase = [NSString stringWithCString:passphraseBuf];

    /* Inform the cryptor that a signature is requested */
    [pgpCryptor doSignature:YES];

    /* Encrypt and sign the data */
    cipherData = [pgpCryptor encryptData:plainData 
			        withKeys:userIDArray 
			      passPhrase:passPhrase
			           error:&pgpError];

    /* Check for errors */
    if(pgpError) {
	fprintf(stderr,"MAIN:  PGP Error %d on Encrypt\n",pgpError);
	exit(1);
    }

    /* Print the results */
    cipherString = [[NSString alloc] initWithData:cipherData encoding:NSASCIIStringEncoding];
    printf("\n%s\n\n",[cipherString cString]);

    /* Clean up and get out */
    [cipherString release];
    [pgpCryptor release];
    [pool release];

    exit(0);
}
