/* This program generates a new public key pair */
/* and adds it to the keyring                   */

#import <stdio.h>
#import <stdlib.h>
#import <pgp.h>
#import <Foundation/Foundation.h>
#import <PGPserver.h>

int main(int argc, char *argv[])
{
    PGPserver *pgpCryptor;
    int i,pgpError;
    NSData *keyData;
    NSString *keyString;
    int entropyPool[128];
    id pool = [[NSAutoreleasePool alloc] init];

    /* Initialize a cryptor object */
    pgpCryptor = [[PGPserver alloc] init];

    if(pgpCryptor == nil) {
	fprintf(stderr,"Could not initialize a PGP cryptor.  See console for details\n");
	exit(1);
    }

    /* Collect entropy.  What I have here is BAD!!  You should time   */
    /* user-entered keystrokes or mouse clicks to collect entropy as  */
    /* is done in the PopOver encryption bundle                       */

    for(i=0; i<128; i++) entropyPool[i] = i;

    /* Generate the key and add to keyring */
    keyData = [pgpCryptor generateNewKeyPair:@"Test User <test@key.org>"
                                     keySize:1024
                                     entropy:entropyPool
                                 entropySize:128
                                  passPhrase:@"mypassphrase"
                                       error:&pgpError];

    /* Print out key */
    keyString = [[NSString alloc] initWithData:keyData encoding:NSASCIIStringEncoding];

    printf("NEW PGP Key:\n\n");
    printf("%s\n\n",[keyString cString]);


    /* Clean up, get out */
    [keyString release];
    [pgpCryptor release];
    [pool release];

    exit(0);
}
