/* This program lists the userIDs of all keys */
/* on the PGP keyring                         */

#import <stdio.h>
#import <stdlib.h>
#import <pgp.h>
#import <Foundation/Foundation.h>
#import <PGPserver.h>

int main(int argc, char *argv[])
{
    PGPserver *pgpCryptor;
    NSArray *userIDArray;
    int i,pgpError;
    id pool = [[NSAutoreleasePool alloc] init];

    /* Initialize a new cryptor object */
    pgpCryptor = [[PGPserver alloc] init];

    if(pgpCryptor == nil) {
	fprintf(stderr,"Could not initialize a PGP cryptor.  See console for details\n");
	exit(1);
    }

    /* Get all userIDs on the keyring */
    userIDArray = [pgpCryptor getAllUserIDs:&pgpError];

    /* Print them out */
    printf("\nFound %d userIDs on pgpKeyRing:\n",[userIDArray count]);

    for(i=0; i<[userIDArray count]; i++)
	printf("   %s\n",[[userIDArray objectAtIndex:i] cString]);

    printf("\n");

    /* Clean up and get out */
    [pgpCryptor release];
    [pool release];

    exit(0);
}
