/* This program will clear-sign a text buffer using */
/* the default signing key on the PGP keyring       */

#import <stdio.h>
#import <stdlib.h>
#import <pgp.h>
#import <Foundation/Foundation.h>
#import <PGPserver.h>

int main(int argc, char *argv[])
{
    PGPserver *pgpCryptor;
    NSData *plainData,*sigData;
    NSString *passPhrase;
    char passphraseBuf[128];
    NSString *sigString;
    int pgpError;
    id pool = [[NSAutoreleasePool alloc] init];

    /* Initialize the cryptor */
    pgpCryptor = [[PGPserver alloc] init];

    /* Initialize some plain text */
    plainData = [[NSData alloc] initWithContentsOfFile:@"plainFile.txt"];

    /* Get the signature passphrase */
    fprintf(stderr,"Passphrase (warning - characters will echo to screen): ");
    gets(passphraseBuf);
    passPhrase = [NSString stringWithCString:passphraseBuf];

    /* Make this a detached signature */
    [pgpCryptor detachSignature:YES];

    /* Sign the data */
    sigData = [pgpCryptor signData:plainData
                        passPhrase:passPhrase
	                     error:&pgpError];

    /* Print signature */
    sigString = [[NSString alloc] initWithData:sigData encoding:NSASCIIStringEncoding];

    printf("\n%s\n\n",[sigString cString]);


    /* Clean up, get out */
    [sigString release];
    [plainData release];
    [pgpCryptor release];
    [pool release];

    exit(0);
}
